! subrotina usada para calcular a norma do resíduo
  
  subroutine norma1(N, AW,AP,AE,BP, TN, norma)

    implicit none

    integer                         :: i            ! número do nó
    real*8                          :: R            ! resíduo do sistema de equações
    integer,intent(in)              :: N            ! número de nós
	real*8, dimension(N)            :: AW,AP,AE,BP  ! coeficiente aP
	real*8, intent(in),dimension(N) :: TN           ! incógnita
    real*8, intent(inout)           :: norma
	  

    norma = 0.0d0

    do i=2,N-1

		R = BP(i) + AW(i)*TN(i-1) + AE(i)*TN(i+1) - AP(i)*TN(i)     ! r= b - Ax 

		norma = norma + dabs(R)
			   
	end do 
       
  
  end subroutine norma1